
#include <stdlib.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include <libgimp/gimp.h>
#include <libgimp/gimpui.h>

#include "verse_gimp.h"

static void query();
static void run(const gchar *name, gint nparams, const GimpParam *param, gint *nreturn_vals, GimpParam **return_vals);

GimpPlugInInfo PLUG_IN_INFO =
{
	NULL,  /* init_proc  */
	NULL,  /* quit_proc  */
	query, /* query_proc */
	run,   /* run_proc   */
};

/* Give the Gimp the info it asks for. */
static void query()
{
	static GimpParamDef args[] =
	{
		{ GIMP_PDB_INT32, "run_mode", "Interactive, [non-interactive]" }
	};
	
	gimp_install_procedure("verse_gimp",
	                       "Connect Gimp with a Verse Network.",
                           "",
                           "Brecht Van Lommel <blendix@pandora.be>",
                           "Brecht Van Lommel <blendix@pandora.be>",
                           "2003",
                           "<Toolbox>/Xtns/_Verse",
                           "RGB*, GRAY*, INDEXED*",
                           GIMP_PLUGIN,
                           G_N_ELEMENTS(args), 0,
                           args, NULL);
}

/* Initialize the plugin. */
static void run (const gchar *name,
                 gint nparams,
                 const GimpParam  *param,
                 gint *nreturn_vals,
                 GimpParam **return_vals)
{
	static GimpParam values[1];
	GimpRunMode      run_mode;
	run_mode = param[0].data.d_int32;
	*nreturn_vals = 1;
	*return_vals  = values;
	values[0].type          = GIMP_PDB_STATUS;
	values[0].data.d_status = GIMP_PDB_SUCCESS;

	if(run_mode == GIMP_RUN_INTERACTIVE)
		gui_run();
}

/* This macro replaces the normal main function. */
MAIN()

